#![feature(is_sorted)]

pub fn selection_sort<T: PartialOrd>(arr: &mut Vec<T>){
    let mut index: usize = 0;
    while let Some(mut smallest) = arr.get(index) {
        let mut smallest_index = index;
        for (item_index, item) in arr[index..].iter().enumerate() {
            if smallest > item {
                smallest = item;
                smallest_index = item_index + index;
            }
        }
        arr.swap(index, smallest_index);
        index += 1;
    }
}


#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn it_works() {
        let mut v = vec![2, 3, 1, 7, 21, 1337, 420];
        selection_sort(&mut v);
        assert!(dbg!(v).is_sorted());
    }
}
